"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_js_1 = require("./utils.js");
const data_js_1 = require("./data.js");
const settings_js_1 = require("./settings.js");
function verbalTime(time = new Date()) {
    if (!(time instanceof Date)) {
        settings_js_1.settings.apply(time);
        return verbalTime;
    }
    utils_js_1.throwIf.notDate(time);
    const h = time.getHours();
    const m = time.getMinutes();
    const { lang } = settings_js_1.settings;
    const ph = data_js_1.phrases[lang];
    if (m === 0) {
        return data_js_1.exactHours[lang][h];
    }
    if (m === 30) {
        return `${ph.half} ${data_js_1.lessLimitAnd30[lang][(h + 1) % 12]}`;
    }
    if (m < settings_js_1.settings.countDownFrom) {
        return `${m} ${ph.minute2(m)} ${data_js_1.lessLimitAnd30[lang][(h + 1) % 12]}`;
    }
    const m60 = 60 - m;
    if (settings_js_1.settings.spellCountDownMinutes) {
        return `${ph.without} ${m60} ${ph.minute3(m60)} ${data_js_1.more30[lang][h % 12]}`;
    }
    if (settings_js_1.settings.spellLastMinuteAsWord && m60 === 1) {
        return `${ph.without} ${ph.minute} ${data_js_1.more30[lang][h % 12]}`;
    }
    return `${ph.without} ${m60} ${data_js_1.more30[lang][h % 12]}`;
}
exports.default = verbalTime;
if (typeof exports.default === 'function') {
    module.exports = exports.default;
    Object.assign(module.exports, exports);
}
